µfmt
====

[![Generated by attribution][attribution-badge]][attribution-url]


v2.5.0
------

Feature release

- Experimental support for alternate sorters, or skipping sorting (#192)
- Replaced experimental `formatter` parameter to `ufmt_bytes` with `ufmt_config` (#192)
- New optional `ufmt_config_factory` parameters to `ufmt_paths` and `ufmt_file`
- Fixed some readme links and formatting (#191)

```text
$ git shortlog -s v2.4.0...v2.5.0
     6	Amethyst Reese
```


v2.4.0
------

Feature release

- Experimental support for using ruff instead of black (#190)
- Correctly output "errors" when more than one error is reported (#187)

```text
$ git shortlog -s v2.3.0...v2.4.0
     4	Amethyst Reese
     1	Tim Hatch
    11	dependabot[bot]
```


v2.3.0
------

Feature release

- New: added `--root` option to override project root discovery (#160)
- Performance: µfmt will start formatting files in parallel while still walking paths (#172)

```text
$ git shortlog -s v2.2.0...v2.3.0
     3	Amethyst Reese
     1	Sergey Goder
     5	dependabot[bot]
```


v2.2.0
------

Feature release

- New: added `--concurrency` option to control number of parallel jobs (#149)
- New: `ufmt_paths` accepts `concurrency` option (#149)
- New: added contributor guide (#159)
- Fix: return exit code 0 when no files were formatted (#151)
- Python: dropped support for Python 3.7 (#158)

```text
$ git shortlog -s v2.1.0...v2.2.0
     3	Amethyst Reese
     2	Sergey Goder
     7	dependabot[bot]
```


v2.1.0
------

Feature release

- Better support for 3.10+ syntax, enable LibCST native parser by default (#127)
- Stronger validation of ufmt config in pyproject.toml (#137)

```text
$ git shortlog -s v2.0.1...v2.1.0
     1	Aarni Koskela
     9	Amethyst Reese
     5	dependabot[bot]
```


v2.0.1
------

Bugfix release

- Fix index error when formatting files that trigger assertion errors in usort/black (#115)

```text
$ git shortlog -s v2.0.0...v2.0.1
     5	Amethyst Reese
     3	dependabot[bot]
```


v2.0.0
------

Feature release

- New: Support for formatting content via stdin (#71)
- New: Final report printed after formatting files (#101)
- New: Added `--quiet` flag for suppressing reports and non-error messages (#101)
- New: Support for running µfmt via GitHub Actions (#107)
- New: Official Visual Studio Code extension for µfmt
- New: Refactored core API for public usage (#66)
- New: Support for passing black/µsort config factories (#66)
- New: Support for passing pre/post-processor functions (#66, #72)
- New: `ufmt_paths` now returns a generator yielding results as they complete (#76)
- New: Added `return_content` flag to API to save before/after bytes on results (#75)
- New: Allow raising `SkipFormatting` from pre/post-processors to skip file (#79)
- Fix: Better error handling when formatting files (#68)
- Fix: Handle CRLF newlines correctly in diff output and results (#85)
- Fix: Added click and libcst to deps list (#90)
- Docs: New API reference covering high- and low-level API
- Deprecated: `ufmt_string` will be removed in v3.0, use `ufmt_bytes`
- Breaking change: Dropped support for Python 3.6
- Breaking change: Requires µsort >= 1.0
- Breaking change: `ufmt_file` and `ufmt_paths` require keyword arguments

```text
$ git shortlog -s action-v1...v2.0.0
     4	Amethyst Reese
     2	dependabot[bot]
```


v2.0.0rc1
---------

Release candidate:

- Fix: fake stdin path now resolvable on Windows (#100)
- Fix: skipped file message sent to stderr (#101)
- New: final report after formatting files (#101)
- New: `--quiet` flag for suppressing reports and non-error messages (#101)

```text
$ git shortlog -s v2.0.0b2...v2.0.0rc1
    10	Amethyst Reese
     1	dependabot[bot]
```


v2.0.0b2
--------

Beta release

- Fix: sorting empty files is now handled correctly (#93)
- Added click and libcst to deps list (#90)

```text
$ git shortlog -s v2.0.0b1...v2.0.0b2
     5	Amethyst Reese
```


v2.0.0b1
--------

Beta release

- Fix: Handle CRLF newlines correctly in diff output and results (#85)
- Fix: preserve given path when formatting stdin (#77)

```text
$ git shortlog -s v2.0.0a4...v2.0.0b1
     6	Amethyst Reese
     2	dependabot[bot]
```


v2.0.0a4
--------

Alpha release

- New: allow raising `SkipFormatting` from pre/post processors to skip file (#79)

```text
$ git shortlog -s v2.0.0a3...v2.0.0a4
     4	Amethyst Reese
```


v2.0.0a3
--------

Alpha release

- New: ufmt_paths now returns a generator yielding results as they complete (#76)
- New: Add return_content flag to API to save before/after bytes on results (#75)
- Fix: export ufmt_stdin and add to API docs
- Fix: correctly pass pre_processor through ufmt_file

```text
$ git shortlog -s v2.0.0a2...v2.0.0a3
    10	Amethyst Reese
```


v2.0.0a2
--------

Alpha release

- Feature: added pre-processors to match post-processors (#72)
- Feature: support for formatting via stdin (#71)
- Fix: better error handling when formatting files (#68)

```text
$ git shortlog -s v2.0.0a1...v2.0.0a2
    15	Amethyst Reese
```


v2.0.0a1
--------

Alpha release

- Feature: Refactor of core API for public usage (#66)
- Feature: Support for passing black/usort config factories (#66)
- Feature: Support for passing post-processor functions (#66)
- Docs: New API reference added, covering high- and low-level API
- Deprecated: `ufmt_string` will be removed in v3.0, use `ufmt_bytes`
- Breaking change: `ufmt_file` and `ufmt_paths` require keyword arguments
- Breaking change: Requires µsort >= 1.0

```text
$ git shortlog -s v1.3.3...v2.0.0a1
    14	Amethyst Reese
```


v1.3.3
------

Maintenance release

- Adds PEP 561 py.typed marker to package
- Exports core API in `__all__` for type checking
- Updated example version pinnings in readme

```text
$ git shortlog -s v1.3.2...v1.3.3
    22	Amethyst Reese
     6	dependabot[bot]
```


v1.3.2
------

Maintenance release

- Disallow flit-core==3.7.0 in PEP 518 build (#56, pypa/flit#530)

```text
$ git shortlog -s v1.3.1...v1.3.2
     4	Amethyst Reese
     7	dependabot[bot]
```


v1.3.1
------

Bugfix release

* Fixed formatting for type stubs (#41, #42)
* Fixed pre-commit hook example in readme (#40)
* Updated dependencies

```text
$ git shortlog -s v1.3.0...v1.3.1
    11	Amethyst Reese
     1	Mathieu Kniewallner
    19	dependabot[bot]
```


v1.3.0
------

Feature release

* Added support for configurable list of excludes to supplement gitignore (#14)
* Added ufmt project-level configuration support in pyproject.toml (#14)
* Read and pass black's config when formatting sources (#11)
* Added pre-commit hook definition for other projects to use (#15)
* Added basic user guide to documentation
* Upgrade to trailrunner 1.1.0

```text
$ git shortlog -s v1.2.1...v1.3.0
    14	Amethyst Reese
    14	Philip Meier
```


v1.2.1
------

Maintenance release

* Add support for reading and obeying .gitignore in project root (#10)
* Improve performance on large repositories using trailrunner (#10)

```text
$ git shortlog -s v1.2...v1.2.1
     4	Amethyst Reese
```


v1.2
----

Feature release

* Major performance improvement via multiprocessing (#4, #5)
* Documented suggested method for pinning black/usort (#8)
* Officially mark µfmt as "stable" (#7)

```text
$ git shortlog -s v1.1...v1.2
     7	Amethyst Reese
     1	Tim Hatch
```


v1.1
----

Feature release

* Added `diff` command to validate and also output unified diff (#2, #3)
* Fixed shortlog for v1.0 in changelog

```text
$ git shortlog -s v1.0...v1.1
     3	Amethyst Reese
```


v1.0
----

Initial release

* `format` command formats files in place
* `check` command validates existing formatting
* Basic readme and sphinx docs

```text
$ git shortlog -s v1.0
    17	Amethyst Reese
     1	Tim Hatch
```

[attribution-badge]:
    https://img.shields.io/badge/generated%20by-attribution-informational
[attribution-url]: https://attribution.omnilib.dev
